--[[
    Author: Kashnars
    Mod name: TreeMeter
    Version: 1.0.0.0
]]

TreeMeter = {}

local _modDirectory = g_currentModDirectory
local soundLevel = 1.00

InitEventClass(TreeMeter, "TreeMeter")

addModEventListener(TreeMeter)

function TreeMeter:update(dt)
	-- Dedicated Server has no player
	if g_currentMission.player==nil then
		return
	end
    
	if TreeMeter.initialised == nil or TreeMeter.initialised == false then
        TreeMeter.initialised = true
    end

    
	if g_currentMission.player:hasHandtoolEquipped() then
		TreeMeter.hTool = g_currentMission.player.baseInformation.currentHandtool
	
		if TreeMeter.hTool ~= nil and TreeMeter.hTool.ringSelector ~= nil then
            TreeMeter.splitShape = 0
            local x,y,z = getWorldTranslation(TreeMeter.hTool.chainsawSplitShapeFocus)
            local nx,ny,nz = localDirectionToWorld(TreeMeter.hTool.chainsawSplitShapeFocus, 1,0,0)
            local yx,yy,yz = localDirectionToWorld(TreeMeter.hTool.chainsawSplitShapeFocus, 0,1,0)
            
            local size = 1

            if TreeMeter.splitShape == 0 then

                TreeMeter.splitShape, minY, maxY, minZ, maxZ = findSplitShape(x,y,z, nx,ny,nz, yx,yy,yz, size, size)

                if TreeMeter.splitShape ~= 0 then
                    local nx2,ny2,nz2 = localDirectionToWorld(TreeMeter.splitShape, 0, 1, 0)
                    local lenBelow, lenAbove = getSplitShapePlaneExtents(TreeMeter.splitShape, x,y,z, nx2,ny2,nz2)

                    g_currentMission:addExtraPrintText("TOTAL: "..(math.floor((lenBelow+lenAbove)*100)/100).." m");
                    g_currentMission:addExtraPrintText("Sides: "..(math.floor((lenAbove)*100)/100).." m || "..(math.floor((lenBelow)*100)/100).." m");
                end
            end
        end
    end
end